diff -Nru a/drivers/acpi/hardware/hwregs.c b/drivers/acpi/hardware/hwregs.c
--- a/drivers/acpi/hardware/hwregs.c	2004-11-10 23:41:02 -05:00
+++ b/drivers/acpi/hardware/hwregs.c	2004-11-10 23:41:02 -05:00
@@ -709,6 +709,7 @@
 	u32                             *value,
 	struct acpi_generic_address     *reg)
 {
+	u64                             address;
 	acpi_status                     status;
 
 
@@ -720,8 +721,14 @@
 	 * a non-zero address within. However, don't return an error
 	 * because the PM1A/B code must not fail if B isn't present.
 	 */
-	if ((!reg) ||
-		(!reg->address)) {
+	if (!reg) {
+		return (AE_OK);
+	}
+
+	/* Get a local copy of the address.  Handles possible alignment issues */
+
+	ACPI_MOVE_64_TO_64 (&address, &reg->address);
+	if (!address) {
 		return (AE_OK);
 	}
 	*value = 0;
@@ -734,14 +741,14 @@
 	case ACPI_ADR_SPACE_SYSTEM_MEMORY:
 
 		status = acpi_os_read_memory (
-				 (acpi_physical_address) reg->address,
+				 (acpi_physical_address) address,
 				 value, width);
 		break;
 
 
 	case ACPI_ADR_SPACE_SYSTEM_IO:
 
-		status = acpi_os_read_port ((acpi_io_address) reg->address,
+		status = acpi_os_read_port ((acpi_io_address) address,
 				 value, width);
 		break;
 
@@ -754,7 +761,7 @@
 
 	ACPI_DEBUG_PRINT ((ACPI_DB_IO, "Read:  %8.8X width %2d from %8.8X%8.8X (%s)\n",
 			*value, width,
-			ACPI_FORMAT_UINT64 (reg->address),
+			ACPI_FORMAT_UINT64 (address),
 			acpi_ut_get_region_name (reg->address_space_id)));
 
 	return (status);
@@ -781,6 +788,7 @@
 	u32                             value,
 	struct acpi_generic_address     *reg)
 {
+	u64                             address;
 	acpi_status                     status;
 
 
@@ -792,8 +800,14 @@
 	 * a non-zero address within. However, don't return an error
 	 * because the PM1A/B code must not fail if B isn't present.
 	 */
-	if ((!reg) ||
-		(!reg->address)) {
+	if (!reg) {
+		return (AE_OK);
+	}
+
+	/* Get a local copy of the address.  Handles possible alignment issues */
+
+	ACPI_MOVE_64_TO_64 (&address, &reg->address);
+	if (!address) {
 		return (AE_OK);
 	}
 
@@ -805,14 +819,14 @@
 	case ACPI_ADR_SPACE_SYSTEM_MEMORY:
 
 		status = acpi_os_write_memory (
-				 (acpi_physical_address) reg->address,
+				 (acpi_physical_address) address,
 				 value, width);
 		break;
 
 
 	case ACPI_ADR_SPACE_SYSTEM_IO:
 
-		status = acpi_os_write_port ((acpi_io_address) reg->address,
+		status = acpi_os_write_port ((acpi_io_address) address,
 				 value, width);
 		break;
 
@@ -825,7 +839,7 @@
 
 	ACPI_DEBUG_PRINT ((ACPI_DB_IO, "Wrote: %8.8X width %2d   to %8.8X%8.8X (%s)\n",
 			value, width,
-			ACPI_FORMAT_UINT64 (reg->address),
+			ACPI_FORMAT_UINT64 (address),
 			acpi_ut_get_region_name (reg->address_space_id)));
 
 	return (status);
diff -Nru a/drivers/acpi/hardware/hwtimer.c b/drivers/acpi/hardware/hwtimer.c
--- a/drivers/acpi/hardware/hwtimer.c	2004-11-10 23:41:02 -05:00
+++ b/drivers/acpi/hardware/hwtimer.c	2004-11-10 23:41:02 -05:00
@@ -149,10 +149,9 @@
 	u32                             end_ticks,
 	u32                             *time_elapsed)
 {
-	u32                             delta_ticks = 0;
-	union uint64_overlay            normalized_ticks;
 	acpi_status                     status;
-	acpi_integer                    out_quotient;
+	u32                             delta_ticks;
+	acpi_integer                    quotient;
 
 
 	ACPI_FUNCTION_TRACE ("acpi_get_timer_duration");
@@ -164,7 +163,7 @@
 
 	/*
 	 * Compute Tick Delta:
-	 * Handle (max one) timer rollovers on 24- versus 32-bit timers.
+	 * Handle (max one) timer rollovers on 24-bit versus 32-bit timers.
 	 */
 	if (start_ticks < end_ticks) {
 		delta_ticks = end_ticks - start_ticks;
@@ -181,22 +180,20 @@
 			delta_ticks = (0xFFFFFFFF - start_ticks) + end_ticks;
 		}
 	}
-	else {
+	else /* start_ticks == end_ticks */ {
 		*time_elapsed = 0;
 		return_ACPI_STATUS (AE_OK);
 	}
 
 	/*
-	 * Compute Duration (Requires a 64-bit divide):
+	 * Compute Duration (Requires a 64-bit multiply and divide):
 	 *
 	 * time_elapsed = (delta_ticks * 1000000) / PM_TIMER_FREQUENCY;
 	 */
-	normalized_ticks.full = ((u64) delta_ticks) * 1000000;
+	status = acpi_ut_short_divide (((u64) delta_ticks) * 1000000,
+			 PM_TIMER_FREQUENCY, &quotient, NULL);
 
-	status = acpi_ut_short_divide (&normalized_ticks.full, PM_TIMER_FREQUENCY,
-			   &out_quotient, NULL);
-
-	*time_elapsed = (u32) out_quotient;
+	*time_elapsed = (u32) quotient;
 	return_ACPI_STATUS (status);
 }
 
